Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_while.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_while.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_while.php	(revision )
@@ -19,48 +19,63 @@
     /**
      * Compiles code for the {while} tag
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                       $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                       $parameter array with compilation parameter
      *
      * @return string compiled code
+     * @throws \SmartyCompilerException
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
+        $compiler->loopNesting++;
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
         $this->openTag($compiler, 'while', $compiler->nocache);
 
         if (!array_key_exists("if condition", $parameter)) {
-            $compiler->trigger_template_error("missing while condition", $compiler->lex->taglineno);
+            $compiler->trigger_template_error("missing while condition", null, true);
         }
 
         // maybe nocache because of nocache variables
         $compiler->nocache = $compiler->nocache | $compiler->tag_nocache;
+        $_output = "<?php\n";
         if (is_array($parameter['if condition'])) {
             if ($compiler->nocache) {
                 $_nocache = ',true';
                 // create nocache var to make it know for further compiling
                 if (is_array($parameter['if condition']['var'])) {
-                    $compiler->template->tpl_vars[trim($parameter['if condition']['var']['var'], "'")] = new Smarty_variable(null, true);
+                    $var = trim($parameter['if condition']['var']['var'], "'");
                 } else {
-                    $compiler->template->tpl_vars[trim($parameter['if condition']['var'], "'")] = new Smarty_variable(null, true);
+                    $var = trim($parameter['if condition']['var'], "'");
                 }
+                if (isset($compiler->template->tpl_vars[$var])) {
+                    $compiler->template->tpl_vars[$var]->nocache = true;
-            } else {
+                } else {
+                    $compiler->template->tpl_vars[$var] = new Smarty_Variable(null, true);
+                }
+            } else {
                 $_nocache = '';
             }
             if (is_array($parameter['if condition']['var'])) {
-                $_output = "<?php if (!isset(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]) || !is_array(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]->value)) \$_smarty_tpl->createLocalArrayVariable(" . $parameter['if condition']['var']['var'] . "$_nocache);\n";
-                $_output .= "while (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]->value" . $parameter['if condition']['var']['smarty_internal_index'] . " = " . $parameter['if condition']['value'] . ") {?>";
+                $_output .= "if (!isset(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] .
+                    "]) || !is_array(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] .
+                    "]->value)) \$_smarty_tpl->smarty->ext->_var->createLocalArrayVariable(\$_smarty_tpl, " . $parameter['if condition']['var']['var'] .
+                    "$_nocache);\n";
+                $_output .= "while (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]->value" .
+                    $parameter['if condition']['var']['smarty_internal_index'] . " = " .
+                    $parameter['if condition']['value'] . ") {?>";
             } else {
-                $_output = "<?php if (!isset(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "])) \$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "] = new Smarty_Variable(null{$_nocache});";
-                $_output .= "while (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "]->value = " . $parameter['if condition']['value'] . ") {?>";
+                $_output .= "if (!isset(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] .
+                    "])) \$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] .
+                    "] = new Smarty_Variable(null{$_nocache});";
+                $_output .= "while (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "]->value = " .
+                    $parameter['if condition']['value'] . ") {?>";
             }
-
-            return $_output;
         } else {
-            return "<?php while ({$parameter['if condition']}) {?>";
+            $_output .= "while ({$parameter['if condition']}) {?>";
-        }
+         }
+        return $_output;
     }
 }
 
@@ -75,19 +90,19 @@
     /**
      * Compiles code for the {/while} tag
      *
-     * @param  array  $args     array with attributes from parser
+     * @param  array                                       $args     array with attributes from parser
-     * @param  object $compiler compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler compiler object
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler)
     {
+        $compiler->loopNesting--;
         // must endblock be nocache?
         if ($compiler->nocache) {
             $compiler->tag_nocache = true;
         }
         $compiler->nocache = $this->closeTag($compiler, array('while'));
-
-        return "<?php }?>";
+        return "<?php }?>\n";
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree_template.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree_template.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree_template.php	(revision )
@@ -0,0 +1,128 @@
+<?php
+/**
+ * Smarty Internal Plugin Templateparser Parse Tree
+ * These are classes to build parse tree in the template parser
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ * @author     Thue Kristensen
+ * @author     Uwe Tews
+ */
+
+/**
+ * Template element
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ * @ignore
+ */
+class Smarty_Internal_ParseTree_Template extends Smarty_Internal_ParseTree
+{
+
+    /**
+     * Array of template elements
+     *
+     * @var array
+     */
+    public $subtrees = Array();
+
+    /**
+     * Create root of parse tree for template elements
+     *
+     */
+    public function __construct()
+    {
+    }
+
+    /**
+     * Append buffer to subtree
+     *
+     * @param \Smarty_Internal_Templateparser $parser
+     * @param Smarty_Internal_ParseTree       $subtree
+     */
+    public function append_subtree(Smarty_Internal_Templateparser $parser, Smarty_Internal_ParseTree $subtree)
+    {
+        if (!empty($subtree->subtrees)) {
+            $this->subtrees = array_merge($this->subtrees, $subtree->subtrees);
+        } else {
+            if ($subtree->data !== '') {
+                $this->subtrees[] = $subtree;
+            }
+        }
+    }
+
+    /**
+     * Append array to subtree
+     *
+     * @param \Smarty_Internal_Templateparser $parser
+     * @param \Smarty_Internal_ParseTree[]    $array
+     */
+    public function append_array(Smarty_Internal_Templateparser $parser, $array = array())
+    {
+        if (!empty($array)) {
+            $this->subtrees = array_merge($this->subtrees, (array) $array);
+        }
+    }
+
+    /**
+     * Prepend array to subtree
+     *
+     * @param \Smarty_Internal_Templateparser $parser
+     * @param \Smarty_Internal_ParseTree[]    $array
+     */
+    public function prepend_array(Smarty_Internal_Templateparser $parser, $array = array())
+    {
+        if (!empty($array)) {
+            $this->subtrees = array_merge((array) $array, $this->subtrees);
+        }
+    }
+
+    /**
+     * Sanitize and merge subtree buffers together
+     *
+     * @param \Smarty_Internal_Templateparser $parser
+     *
+     * @return string template code content
+     */
+    public function to_smarty_php(Smarty_Internal_Templateparser $parser)
+    {
+        $code = '';
+        for ($key = 0, $cnt = count($this->subtrees); $key < $cnt; $key ++) {
+            if ($this->subtrees[$key] instanceof Smarty_Internal_ParseTree_Text) {
+                $subtree = $this->subtrees[$key]->to_smarty_php($parser);
+                while ($key + 1 < $cnt && ($this->subtrees[$key + 1] instanceof Smarty_Internal_ParseTree_Text ||
+                        $this->subtrees[$key + 1]->data == '')) {
+                    $key ++;
+                    if ($this->subtrees[$key]->data == '') {
+                        continue;
+                    }
+                    $subtree .= $this->subtrees[$key]->to_smarty_php($parser);
+                }
+                if ($subtree == '') {
+                    continue;
+                }
+                $code .= preg_replace('/((<%)|(%>)|(<\?php)|(<\?)|(\?>)|(<\/?script))/', "<?php echo '\$1'; ?>\n",
+                                      $subtree);
+                continue;
+            }
+            if ($this->subtrees[$key] instanceof Smarty_Internal_ParseTree_Tag) {
+                $subtree = $this->subtrees[$key]->to_smarty_php($parser);
+                while ($key + 1 < $cnt && ($this->subtrees[$key + 1] instanceof Smarty_Internal_ParseTree_Tag ||
+                        $this->subtrees[$key + 1]->data == '')) {
+                    $key ++;
+                    if ($this->subtrees[$key]->data == '') {
+                        continue;
+                    }
+                    $subtree = $parser->compiler->appendCode($subtree, $this->subtrees[$key]->to_smarty_php($parser));
+                }
+                if ($subtree == '') {
+                    continue;
+                }
+                $code .= $subtree;
+                continue;
+            }
+            $code .= $this->subtrees[$key]->to_smarty_php($parser);
+        }
+        return $code;
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_codeframe.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_codeframe.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_codeframe.php	(revision )
@@ -0,0 +1,94 @@
+<?php
+/**
+ * Smarty Internal Extension
+ * This file contains the Smarty template extension to create a code frame
+ *
+ * @package    Smarty
+ * @subpackage Template
+ * @author     Uwe Tews
+ */
+
+/**
+ * Class Smarty_Internal_Extension_CodeFrame
+ * Create code frame for compiled and cached templates
+ */
+class Smarty_Internal_Runtime_CodeFrame
+{
+    /**
+     * Create code frame for compiled and cached templates
+     *
+     * @param Smarty_Internal_Template              $_template
+     * @param string                                $content optional template content
+     * @param string                                $functions compiled template function and block code
+     * @param bool                                  $cache   flag for cache file
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler
+     *
+     * @return string
+     */
+    public function create(Smarty_Internal_Template $_template, $content = '', $functions = '', $cache = false,
+                           Smarty_Internal_TemplateCompilerBase $compiler = null)
+    {
+        // build property code
+        $properties[ 'has_nocache_code' ] = $_template->compiled->has_nocache_code;
+        $properties[ 'version' ] = Smarty::SMARTY_VERSION;
+        $properties[ 'unifunc' ] = 'content_' . str_replace(array('.', ','), '_', uniqid('', true));
+        if (!$cache) {
+            $properties[ 'file_dependency' ] = $_template->compiled->file_dependency;
+            $properties[ 'includes' ] = $_template->compiled->includes;
+            if (!empty($compiler->tpl_function)) {
+                $properties[ 'tpl_function' ] = $compiler->tpl_function;
+            }
+        } else {
+            $properties[ 'file_dependency' ] = $_template->cached->file_dependency;
+            $properties[ 'cache_lifetime' ] = $_template->cache_lifetime;
+            if (!empty($_template->tpl_function)) {
+                $properties[ 'tpl_function' ] = $_template->tpl_function;
+            }
+        }
+        $output = "<?php\n";
+        $output .= "/* Smarty version " . Smarty::SMARTY_VERSION . ", created on " . strftime("%Y-%m-%d %H:%M:%S") .
+            "\n  from \"" . $_template->source->filepath . "\" */\n\n";
+
+        $dec = "\$_smarty_tpl->smarty->ext->_validateCompiled->decodeProperties(\$_smarty_tpl, " .
+            var_export($properties, true) . ',' . ($cache ? 'true' : 'false') . ")";
+        $output .= "if ({$dec}) {\n";
+        $output .= "function {$properties['unifunc']} (\$_smarty_tpl) {\n";
+        // include code for plugins
+        if (!$cache) {
+            if (!empty($_template->compiled->required_plugins[ 'compiled' ])) {
+                foreach ($_template->compiled->required_plugins[ 'compiled' ] as $tmp) {
+                    foreach ($tmp as $data) {
+                        $file = addslashes($data[ 'file' ]);
+                        if (is_array($data[ 'function' ])) {
+                            $output .= "if (!is_callable(array('{$data['function'][0]}','{$data['function'][1]}'))) require_once '{$file}';\n";
+                        } else {
+                            $output .= "if (!is_callable('{$data['function']}')) require_once '{$file}';\n";
+                        }
+                    }
+                }
+            }
+            if ($_template->caching && !empty($_template->compiled->required_plugins[ 'nocache' ])) {
+                $_template->compiled->has_nocache_code = true;
+                $output .= "echo '/*%%SmartyNocache:{$_template->compiled->nocache_hash}%%*/<?php \$_smarty = \$_smarty_tpl->smarty; ";
+                foreach ($_template->compiled->required_plugins[ 'nocache' ] as $tmp) {
+                    foreach ($tmp as $data) {
+                        $file = addslashes($data[ 'file' ]);
+                        if (is_Array($data[ 'function' ])) {
+                            $output .= addslashes("if (!is_callable(array('{$data['function'][0]}','{$data['function'][1]}'))) require_once '{$file}';\n");
+                        } else {
+                            $output .= addslashes("if (!is_callable('{$data['function']}')) require_once '{$file}';\n");
+                        }
+                    }
+                }
+                $output .= "?>/*/%%SmartyNocache:{$_template->compiled->nocache_hash}%%*/';\n";
+            }
+        }
+        $output .= "?>\n";
+        $output .= $content;
+        $output .= "<?php }\n?>";
+        $output .= $functions;
+        $output .= "<?php }\n";
+        // remove unneeded PHP tags
+        return preg_replace(array('/\s*\?>[\n]?<\?php\s*/', '/\?>\s*$/'), array("\n", ''), $output);
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/plugins/modifier.truncate.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifier.truncate.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifier.truncate.php	(revision )
@@ -1,0 +1,0 @@
